-- Additional semi keys made by AR162b for BeamNG.Drive

local M = {}

	local LiftState = 0

local function onInit()
	local LiftState = 0
  electrics.values['tilt'] = 0
  electrics.values['tilt_input'] = 0
	electrics.values['lift3'] = 0
	electrics.values['lift_lo'] = 0

end

local function reset()
	onInit()
end


local taglift = 'lift_latch'

local function updateGFX(dt)
	
    local vals = M.values

  electrics.values['tilt'] = math.min(1, math.max(-0.0, (electrics.values['tilt'] + electrics.values['tilt_input'] * dt * 0.25)))
  
		if electrics.values['doorR'] == 0 then
		electrics.values['lift3'] = 0
		else 
		electrics.values['lift3'] = math.min(1, math.max(-1.0, (electrics.values['lift3'] + electrics.values['tilt_input'] * dt * 0.5)))
		end
		
		if electrics.values['doorR'] == 0 then
		electrics.values['lift2'] = 0
		elseif electrics.values['lift2'] == 2 then
		electrics.values['lift2'] = -1
		end
	
	if (electrics.values.lift3 <= 0.1 and electrics.values.lift3 >= -0.1 and electrics.values.doorR == 1)  then
        beamstate.attachCouplers(taglift)
    elseif electrics.values.lift3 <= -0.85 then
		beamstate.attachCouplers(taglift)
	else
        beamstate.detachCouplers(taglift)
    end
	
	if (electrics.values.lift3 >= 0.9)  then
		electrics.values['lift_lo'] = 1  
	else
        electrics.values['lift_lo'] = 0
    end
				

end

local function tiltBed(value)
  electrics.values.tilt_input = value
end



-- public interface
M.Reset       = Reset
M.onInit	= onInit
M.updateGFX   = updateGFX
M.tiltBed = tiltBed
return M