-- Additional semi keys made by AR162b for BeamNG.Drive

local M = {}

	local LiftState = 0

local function onInit()
	local LiftState = 0
	electrics.values['lift3'] = 0
	electrics.values['extend_flatbed'] = 0
	electrics.values['extend_flatbed_input'] = 1
	electrics.values['extend_flatbed_timer'] = 0
	electrics.values['lift_lo'] = 0

end

local function reset()
	onInit()
end

local taglift = 'lift_latch'

local function updateGFX(dt)
	
    local vals = M.values
	
	if electrics.values['extend_input'] < 0 then
		electrics.values['extend_flatbed_input'] = 0
	elseif 
		electrics.values['extend_input'] > 0 then
		electrics.values['extend_flatbed_input'] = 1
	end

	if electrics.values['doorL'] == 0 then
	electrics.values['lift3'] = 0
		if electrics.values['extend_flatbed_timer'] == 0 then
		electrics.values['extend_flatbed'] = 0
		else
		electrics.values['extend_flatbed_timer'] = electrics.values['extend_flatbed_timer'] - 1
		end
	else 
	electrics.values['lift3'] = math.min(1, math.max(-1.0, (electrics.values['lift3'] - electrics.values['tilt_input'] * dt * 0.5)))
		if electrics.values['extend_flatbed_input'] == 1 then
		electrics.values['extend_flatbed'] = 1
		else
		electrics.values['extend_flatbed'] = 0.04
		electrics.values['extend_flatbed_timer'] = 400
		end
	end

	if (electrics.values.lift3 <= 0.1 and electrics.values.lift3 >= -0.1 and electrics.values.doorR == 1)  then
        beamstate.attachCouplers(taglift)
    elseif electrics.values.lift3 <= -0.85 then
		beamstate.attachCouplers(taglift)
	else
        beamstate.detachCouplers(taglift)
    end
	
	if (electrics.values.lift3 >= 0.9)  then
		electrics.values['lift_lo'] = 1  
	else
        electrics.values['lift_lo'] = 0
    end	

end
			
	  


-- public interface
M.Reset       = Reset
M.onInit	= onInit
M.updateGFX   = updateGFX

return M